3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [[-i | -o] <path>...]'
11 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
16 unmerged_ok_if_status=--unmerged ;;
19 unmerged_ok_if_status= ;;
24 echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
32 cp -p "$THIS_INDEX" "$NEXT_INDEX"
36 # If TMP_INDEX is defined, that means we are doing
37 # "--only" partial commit, and that index file is used
38 # to build the tree for the commit. Otherwise, if
39 # NEXT_INDEX exists, that is the index file used to
40 # make the commit. Otherwise we are using as-is commit
41 # so the regular index file is what we use to compare.
42 if test '' != "$TMP_INDEX"
44 GIT_INDEX_FILE="$TMP_INDEX"
46 elif test -f "$NEXT_INDEX"
48 GIT_INDEX_FILE="$NEXT_INDEX"
52 case "$status_only" in
56 git-runstatus ${color} \
57 ${verbose:+--verbose} \
59 ${untracked_files:+--untracked}
63 test -z "$TMP_INDEX" || {
64 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
69 ################################################################
70 # Command line argument parsing and sanity checking
89 while case "$#" in 0) break;; esac
92 -F|--F|-f|--f|--fi|--fil|--file)
93 case "$#" in 1) usage ;; esac
102 log_given=t$log_given
103 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
106 --F=*|--f=*|--fi=*|--fil=*|--file=*)
108 log_given=t$log_given
109 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
116 --au=*|--aut=*|--auth=*|--autho=*|--author=*)
117 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
120 --au|--aut|--auth|--autho|--author)
121 case "$#" in 1) usage ;; esac
126 -e|--e|--ed|--edi|--edit)
130 -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
134 -o|--o|--on|--onl|--only)
138 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
139 case "$#" in 1) usage ;; esac
141 log_given=m$log_given
142 if test "$log_message" = ''
146 log_message="$log_message
154 log_given=m$log_given
155 if test "$log_message" = ''
157 log_message=`expr "z$1" : 'z-m\(.*\)'`
159 log_message="$log_message
161 `expr "z$1" : 'z-m\(.*\)'`"
166 --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
167 log_given=m$log_given
168 if test "$log_message" = ''
170 log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
172 log_message="$log_message
174 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
179 -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
184 --a|--am|--ame|--amen|--amend)
186 log_given=t$log_given
191 case "$#" in 1) usage ;; esac
193 log_given=t$log_given
198 --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
199 --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
200 --reedit-messag=*|--reedit-message=*)
201 log_given=t$log_given
202 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
206 --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
207 --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
209 case "$#" in 1) usage ;; esac
211 log_given=t$log_given
217 case "$#" in 1) usage ;; esac
219 log_given=t$log_given
224 --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
225 --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
227 log_given=t$log_given
228 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
232 --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
233 --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
234 case "$#" in 1) usage ;; esac
236 log_given=t$log_given
241 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
245 -q|--q|--qu|--qui|--quie|--quiet)
249 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
253 -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
254 --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
255 --untracked-file|--untracked-files)
271 case "$edit_flag" in t) no_edit= ;; esac
273 ################################################################
274 # Sanity check options
276 case "$amend,$initial_commit" in
278 die "You do not have anything to amend." ;;
280 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
281 die "You are in the middle of a merge -- cannot amend."
287 die "Only one of -c/-C/-F/--amend can be used." ;;
289 die "Option -m cannot be combined with -c/-C/-F/--amend." ;;
292 case "$#,$also,$only,$amend" in
294 die "Only one of --include/--only can be used." ;;
296 die "No paths with --include/--only does not make sense." ;;
298 only_include_assumed="# Clever... amending the last one with dirty index." ;;
302 only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
307 case "$all,$also,$#" in
309 die "Cannot use -a and -i at the same time." ;;
311 die "Paths with -a does not make sense." ;;
313 die "No paths with -i does not make sense." ;;
316 ################################################################
317 # Prepare index to have a tree to be committed
324 GIT_INDEX_FILE="$NEXT_INDEX" &&
325 export GIT_INDEX_FILE &&
326 git-diff-files --name-only -z |
327 git-update-index --remove -z --stdin
332 git-ls-files --error-unmatch -- "$@" >/dev/null || exit
334 git-diff-files --name-only -z -- "$@" |
337 GIT_INDEX_FILE="$NEXT_INDEX" &&
338 export GIT_INDEX_FILE &&
339 git-update-index --remove -z --stdin
347 if test -f "$GIT_DIR/MERGE_HEAD"
349 refuse_partial "Cannot do a partial commit during a merge."
351 TMP_INDEX="$GIT_DIR/tmp-index$$"
352 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
354 # Build a temporary index and update the real index
356 if test -z "$initial_commit"
358 cp "$THIS_INDEX" "$TMP_INDEX"
359 GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
364 echo "$commit_only" |
365 GIT_INDEX_FILE="$TMP_INDEX" \
366 git-update-index --add --remove --stdin &&
369 echo "$commit_only" |
371 GIT_INDEX_FILE="$NEXT_INDEX"
372 export GIT_INDEX_FILE
373 git-update-index --remove --stdin
380 ################################################################
381 # If we do as-is commit, the index file will be THIS_INDEX,
382 # otherwise NEXT_INDEX after we make this commit. We leave
383 # the index as is if we abort.
385 if test -f "$NEXT_INDEX"
387 USE_INDEX="$NEXT_INDEX"
389 USE_INDEX="$THIS_INDEX"
392 GIT_INDEX_FILE="$USE_INDEX" \
393 git-update-index -q $unmerged_ok_if_status --refresh || exit
395 ################################################################
396 # If the request is status, just show it and exit.
404 ################################################################
405 # Grab commit message, write out tree and make commit.
407 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
411 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
413 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
417 if test "$log_message" != ''
420 elif test "$logfile" != ""
422 if test "$logfile" = -
425 echo >&2 "(reading log message from standard input)"
430 elif test "$use_commit" != ""
432 encoding=$(git config i18n.commitencoding || echo UTF-8)
433 git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
434 sed -e '1,/^$/d' -e 's/^ //'
435 elif test -f "$GIT_DIR/MERGE_MSG"
437 cat "$GIT_DIR/MERGE_MSG"
438 elif test -f "$GIT_DIR/SQUASH_MSG"
440 cat "$GIT_DIR/SQUASH_MSG"
441 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
445 need_blank_before_signoff=
446 tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
447 grep 'Signed-off-by:' >/dev/null || need_blank_before_signoff=yes
449 test -z "$need_blank_before_signoff" || echo
450 git-var GIT_COMMITTER_IDENT | sed -e '
454 } >>"$GIT_DIR"/COMMIT_EDITMSG
458 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
460 echo "# It looks like you may be committing a MERGE."
461 echo "# If this is not correct, please remove the file"
462 echo "# $GIT_DIR/MERGE_HEAD"
463 echo "# and try again"
465 fi >>"$GIT_DIR"/COMMIT_EDITMSG
468 if test '' != "$use_commit"
472 s/'\''/'\''\\'\'\''/g
474 s/^author \([^<]*\) <[^>]*> .*$/\1/
476 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
479 s/^author [^<]* <\([^>]*\)> .*$/\1/
481 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
484 s/^author [^<]* <[^>]*> \(.*\)$/\1/
486 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
491 encoding=$(git config i18n.commitencoding || echo UTF-8)
492 set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
493 LANG=C LC_ALL=C sed -ne "$pick_author_script"`
494 eval "$set_author_env"
495 export GIT_AUTHOR_NAME
496 export GIT_AUTHOR_EMAIL
497 export GIT_AUTHOR_DATE
499 if test '' != "$force_author"
501 GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
502 GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
503 test '' != "$GIT_AUTHOR_NAME" &&
504 test '' != "$GIT_AUTHOR_EMAIL" ||
505 die "malformed --author parameter"
506 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
510 if test -z "$initial_commit"
513 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
514 rloga='commit (merge)'
515 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
516 elif test -n "$amend"; then
517 rloga='commit (amend)'
518 PARENTS=$(git-cat-file commit HEAD |
519 sed -n -e '/^$/q' -e 's/^parent /-p /p')
521 current="$(git-rev-parse --verify HEAD)"
523 if [ -z "$(git-ls-files)" ]; then
524 echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
528 rloga='commit (initial)'
532 if test -z "$no_edit"
536 echo "# Please enter the commit message for your changes."
537 echo "# (Comment lines starting with '#' will not be included)"
538 test -z "$only_include_assumed" || echo "$only_include_assumed"
540 } >>"$GIT_DIR"/COMMIT_EDITMSG
542 # we need to check if there is anything to commit
543 run_status >/dev/null
545 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
547 rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
554 case "${VISUAL:-$EDITOR},$TERM" in
556 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
557 echo >&2 "Please supply the commit log message using either"
558 echo >&2 "-m or -F option. A boilerplate log message has"
559 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
563 git-var GIT_AUTHOR_IDENT > /dev/null || die
564 git-var GIT_COMMITTER_IDENT > /dev/null || die
565 ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
571 if test -x "$GIT_DIR"/hooks/commit-msg
573 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
577 if test -z "$no_edit"
585 ' "$GIT_DIR"/COMMIT_EDITMSG
587 cat "$GIT_DIR"/COMMIT_EDITMSG
589 git-stripspace >"$GIT_DIR"/COMMIT_MSG
591 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
596 if test -z "$TMP_INDEX"
598 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
600 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
603 commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
604 rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
605 git-update-ref -m "$rloga: $rlogm" HEAD $commit "$current" &&
606 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
607 if test -f "$NEXT_INDEX"
609 mv "$NEXT_INDEX" "$THIS_INDEX"
614 echo >&2 "* no commit message? aborting commit."
618 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
619 if test -d "$GIT_DIR/rr-cache"
626 if test -x "$GIT_DIR"/hooks/post-commit
628 "$GIT_DIR"/hooks/post-commit
632 echo "Created${initial_commit:+ initial} commit $commit"
633 git-diff-tree --shortstat --summary --root --no-commit-id HEAD --